// BoBTweak.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "BoBTweak.h"
#include "BoBTweakDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_Version;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_VERSION, m_Version);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoBTweakApp

BEGIN_MESSAGE_MAP(CBoBTweakApp, CWinApp)
	//{{AFX_MSG_MAP(CBoBTweakApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoBTweakApp construction

CBoBTweakApp::CBoBTweakApp()
{
	m_SFC = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBoBTweakApp object

CBoBTweakApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBoBTweakApp initialization

BOOL CBoBTweakApp::InitInstance()
{
	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Parse the command line to see if launched as OLE server
	if (RunEmbedded() || RunAutomated())
	{
		// Register all OLE server (factories) as running.  This enables the
		//  OLE libraries to create objects from other applications.
		COleTemplateServer::RegisterAll();
	}
	else
	{
		// When a server application is launched stand-alone, it is a good idea
		//  to update the system registry in case it has been damaged.
		COleObjectFactory::UpdateRegistryAll();

		// Register tool in Creatures registry key
		RegisterCreaturesTool();

#ifndef _DEBUG
		return FALSE;
#endif
	}

	CBoBTweakDlg dlg;

	m_pMainWnd = &dlg;

	// Set application's registry key
	SetRegistryKey(_T("BoBWare"));

	// Get Creatures Dispatch interface
	m_SFC = new ISFC;
	if (m_SFC == NULL)
	{
		AfxMessageBox(IDS_CREATE_CREATURES_FAILED);
		return FALSE;
	}

	if (!m_SFC->CreateDispatch(_T("SFC2.OLE")))
	{
		AfxMessageBox(IDS_CREATE_CREATURES_FAILED);
		return FALSE;
	}

	int nResponse = dlg.DoModal();

	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CBoBTweakApp::OnAppAbout() 
{
	CAboutDlg dlgAbout;

	dlgAbout.DoModal();
}

int CBoBTweakApp::ExitInstance() 
{
	if (m_SFC)
	{
		delete m_SFC;
		m_SFC = NULL;
	}
	
	return CWinApp::ExitInstance();
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CString sFormat;
	CString sVersion;
	HINSTANCE hRes;
	HRSRC hVersionResource;
	HGLOBAL hVersionResourceMem;
	void far* pVersionInfo;
	VS_FIXEDFILEINFO* pFixedFileInfo;
	UINT ulen;
	
	m_Version.GetWindowText(sFormat);

	hRes = AfxGetResourceHandle();

	hVersionResource = FindResource(hRes, MAKEINTRESOURCE(VS_VERSION_INFO), RT_VERSION);
	hVersionResourceMem = LoadResource(hRes, hVersionResource);
	pVersionInfo = LockResource(hVersionResourceMem);
	VerQueryValue(pVersionInfo, "\\", (void **)(&pFixedFileInfo), &ulen);
	sVersion.Format(sFormat, HIWORD(pFixedFileInfo->dwProductVersionMS), LOWORD(pFixedFileInfo->dwProductVersionMS));

	m_Version.SetWindowText(sVersion);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CBoBTweakApp::RegisterCreaturesTool()
{
	LONG nResult;
	HKEY hKey;
	DWORD dwIndex;
	DWORD dwLen;
	DWORD dwLen2;
	DWORD dwType;
	TCHAR lpszName[256];
	TCHAR lpszValue[256];
	CString sName;
	CString sValue;
	int iToolIndex;

	iToolIndex = -1;

	nResult = RegOpenKey(HKEY_CURRENT_USER, _T("Software\\CyberLife Technology\\Creatures 2\\1.0"), &hKey);
	if (nResult == ERROR_SUCCESS)
	{
		dwIndex = 0;

		do
		{
			dwLen = 256;
			dwLen2 = 256;
			nResult = RegEnumValue(hKey, dwIndex, lpszName, &dwLen, NULL, &dwType, (LPBYTE)lpszValue, &dwLen2);
			if (nResult == ERROR_SUCCESS)
			{
				if (_tcsnicmp(lpszName, _T("Tool"), 4) == 0)
				{
					int iTmp;

					iTmp = _ttoi(lpszName + 4);

					if (_tcsstr(lpszValue, _T("BoBTweak")) != NULL)
					{
						iToolIndex = -2;
						break;
					}

					if (iTmp > iToolIndex)
						iToolIndex = iTmp;
				}
			}
			dwIndex++;
		} while (nResult != ERROR_NO_MORE_ITEMS);

		iToolIndex++;

		if (iToolIndex >= 0)
		{
			sName.Format("Tool%d", iToolIndex);

			nResult = RegSetValueEx(hKey, sName, NULL, REG_SZ, (LPBYTE)g_cszToolDefinition, strlen(g_cszToolDefinition));
		}

		RegCloseKey(hKey);
	}

	if (nResult == ERROR_SUCCESS)
		return TRUE;
	else
		return FALSE;
}
